/* LaunchBBS */
#include <String.h>
#include <stdlib.h>
#include <packages.h>
#include <TabbyUtils.h>
#include <TabbyUtils.proto.h>
short sprintf(unsigned char *dest, char *fmt, ...);
short sscanf(unsigned char *dest, char *fmt, ...);



extern short	MultiFinder,	/* these four globals must be declared in your main program */
				MyvRefNum;
extern Str255	BBSName,
				ProgName;


pascal OSErr LaunchIt(pLaunchStruct pLnch)
	= {0x205F, 0xA9F2, 0x3E80};

/* pops pointer into A0, calls Launch, pops D0 error code into result:
	  MOVE.L  (A7)+,A0
	  _Launch
	  MOVE.W  D0,(A7)  ; since it MAY return */

OSErr LaunchBBS(unsigned char *BBSName, short MyvRefNum, Boolean subLaunch)		/* Sublaunch if true and launch if false	*/
{  /* DoLaunch */
	struct LaunchStruct	myLaunch;
	HFileInfo		myPB;
	unsigned char	   		*dirNameStr;
	Str255			s;
	OSErr			err;	
	unsigned long	sleep=10;
	short				i;
	EventRecord		event;
	
	dirNameStr = BBSName;	/*initialize to file selected*/

	/*Get the Finder flags*/
	myPB.ioNamePtr= (StringPtr)dirNameStr;
	myPB.ioVRefNum= MyvRefNum;
	myPB.ioFDirIndex= 0;
	myPB.ioDirID = 0;
	if((err = PBGetCatInfo((CInfoPBPtr) &myPB,false))){
		sprintf(s,"ERROR %d on PBGetCatInfo of %s",err,PtoCstr(BBSName));
		CtoPstr(BBSName);
		Log(s);
		return(err);
	}

	/*Set the current volume to where the target application is*/
	if((err = SetVol(nil, MyvRefNum))){
		sprintf(s,"ERROR %d on SetVol",err);
		Log(s);
		return(err);
	}

	/*Set up the launch parameters*/
	myLaunch.appName = (Ptr)BBSName;		/*pointer to our fileName*/
	myLaunch.memUse = 0;			/*we don't want alternate screen or sound buffers*/
	myLaunch.LC[0] = 'L'; 			/*set up LC so as to tell Launch that there is non-junk next*/
	myLaunch.LC[1] = 'C';
	myLaunch.extBlocLen = 6;		/*length of param. block past this long word*/
	/*copy flags; set bit 6 of low byte to 1 for RO access:*/
	myLaunch.fFlags = myPB.ioFlFndrInfo.fdFlags;	/*from _GetCatInfo*/
	/* Test subLaunch and set launchFlags accordingly	*/
	if ( subLaunch )
		myLaunch.launchFlags = 0xC0000000;	/*set BOTH hi bits for a sublaunch	*/
	else
		myLaunch.launchFlags = 0x00000000;	/* Just launch then quit		*/
		
	err = LaunchIt(&myLaunch);		/* call _Launch			*/
	if(subLaunch)
		for(i=0; i<20; i++)
			WaitNextEvent(everyEvent, &event, sleep, 0L);

	if(err < 0){
	/* the launch failed, so put up an alert to inform the user */
		sprintf(s,"ERROR %d on LaunchIt",err);
		Log(s);
		return(err);
	} else
		return noErr;
} /*DoLaunch*/
/**************************************************************************************/
OSErr LaunchNext(short MyvRefNum)
{
	short		fp,
			err;
	Str255	s;
	unsigned char	*Buffer,*Tok;
	unsigned long ByteCount;
	
	/* open the file */
	if((err = FSOpen("\pLaunch.next",MyvRefNum,&fp))){
		err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
		return(err);
	}
	
	/* calculate the size of the file */
	if((err = GetEOF(fp,&ByteCount))){
		FSClose(fp);
		sprintf(s,"ERROR %d finding EOF of Launch.next file",err);
		Log(s);
		err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
		return(err);
	}
	
	/* allocate a buffer to load it into */
	if(!(Buffer = (unsigned char *)NewPtr(ByteCount + 1))){
		FSClose(fp);
		Log((unsigned char *)"ERROR Not enough memory to load the launch.next file");
		err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
		return(25);
	}
	
	/* Read the entire file in */
	if((err = FSRead(fp,&ByteCount,Buffer))){
		FSClose(fp);
		DisposPtr(Buffer);
		sprintf(s,"ERROR %d reading Launch.next file",err);
		Log(s);
		err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
		return(err);
	}
	Tok = Buffer;
	Tok += ByteCount;
	*Tok = 0;
	Tok = strtok(Buffer,(unsigned char *)",\r");
	strcpy(s,Tok);	/* copy the first one to s */
	Tok += strlen(Tok) + 1;
	if(!(ByteCount = strlen(Tok))){
		/* delete the Launch.Next file */
		FSClose(fp);
		if((err = FSDelete("\pLaunch.Next",MyvRefNum))){
			sprintf(s,"ERROR %d Setting EOF of Launch.next file",err);
			Log(s);
		}
	} else { /* this isn't the last in the Launch.next series */
		/* clear the file */
		if((err = SetEOF(fp,0l))){
			FSClose(fp);
			DisposPtr(Buffer);
			sprintf(s,"ERROR %d Setting EOF of Launch.next file",err);
			Log(s);
			err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
			return(err);
		}
	
		/* Go to the beginning */
		if((err = SetFPos(fp,fsFromStart,0L))){
			FSClose(fp);
			DisposPtr(Buffer);
			sprintf(s,"ERROR %d Setting FilePos of Launch.next file",err);
			Log(s);
			err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
			return(err);
		}
	
		/* write the new file back out */
		if((err = FSWrite(fp,&ByteCount,Tok))){
			FSClose(fp);
			DisposPtr(Buffer);
			sprintf(s,"ERROR %d Writing Launch.next file",err);
			Log(s);
			err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */
			return(err);
		}
		/* close the file */
		FSClose(fp);
	}
	DisposPtr(Buffer);
	if(!strcmp(s,(unsigned char *)"BBS")){
		strcpy(s,PtoCstr(BBSName));
		CtoPstr(BBSName);
	}
	if((err = LaunchBBS(CtoPstr(s),MyvRefNum,FALSE)))
		err = LaunchBBS(BBSName,MyvRefNum,FALSE);	/* Last Ditch Effort */

	return(err);
}
/********************************************************************************/
short Log(unsigned char *Msg)
{
	short		fp,
			err;
	Str255	s,
			Date,
			Time;
			
	unsigned long	longsecs,
					ByteCount;
	Handle			IntlRes;
	
	/* open the file */
	/* attempt to open the Tabby Log first */
	if((err = FSOpen("\p:Tabby:Tabby Log",MyvRefNum,&fp)))
		/* Then try the Copernicus Log */
		if((err = FSOpen("\p:Common Folder:Log",MyvRefNum,&fp))){
			sprintf(s,"%s Log",ProgName);
			if((err = FSOpen(CtoPstr(s),MyvRefNum,&fp))){
				if(err == fnfErr){
					if((err = Create(s,MyvRefNum,'QED1','TEXT')))
						return(err);
					if((err = FSOpen(s,MyvRefNum,&fp)))
						return(err);
				} else
					return(err);
			}
		}
	/* move to the end */
	if((err = SetFPos(fp,fsFromLEOF,0L))){
		FSClose(fp);
		return(err);
	}
	
	/* Make the string */
	GetDateTime(&longsecs);
	if((IntlRes = GetResource('INTL',0))){
		IUDatePString(longsecs,shortDate,Date,IntlRes);
		IUTimePString(longsecs,TRUE,Time,IntlRes);
		ReleaseResource(IntlRes);
	} else {
		IUDateString(longsecs,shortDate,Date);
		IUTimeString(longsecs,TRUE,Time);
	}
	sprintf(s,"%s %s %s - ",PtoCstr(Date),PtoCstr(Time),ProgName);
	
	/* write it to the file */
	ByteCount = (unsigned long)strlen(s);
	FSWrite(fp,&ByteCount,s);	/* I don't care about errors */

	ByteCount = (unsigned long)strlen(Msg);
	FSWrite(fp,&ByteCount,Msg);	/* I don't care about errors */
	
	*s = '\r';
	ByteCount = 1;
	FSWrite(fp,&ByteCount,s);	/* I don't care about errors */
	
	/* close the file */
	FSClose(fp);
	
	return(0);
}
/****************************************************************************************/
short GetTabbyConfigStuff(void)
{
	short		fp,
			err;
	Str255	s;
	
	/* first try Tabby one */
	if((err = FSOpen("\p:Tabby:Tabby Setup",MyvRefNum,&fp)))
		/* then try Copernicus one */
		if((err = FSOpen("\p:Common Folder:Setup",MyvRefNum,&fp))){
			sprintf(s,"ERROR %d opening Setup File",err);
			Log(s);
			return(err);
		}
	MyReadLine(fp,BBSName,TRUE);
	CtoPstr(BBSName);
	MyReadLine(fp,s,TRUE);
	MultiFinder = (*s == '1');
	FSClose(fp);
	return(0);
}
/******************************************************************************/
short GetGenericPath(unsigned char *GenPath)
{
	short		fp,
			err;
	Str255	s;
	
	/* try Tabby First */
	if((err = FSOpen("\pGeneric",MyvRefNum,&fp)))	/* try tabby first */
		if((err = FSOpen("\pCommon",MyvRefNum,&fp))){	/* try copernicus next */
			sprintf(s,"ERROR %d opening Generic or Common file",err);
			Log(s);
			return(err);
		}
			
	MyReadLine(fp,GenPath,TRUE);
	FSClose(fp);
	return(0);
}
/*****************************************************************************/
unsigned long MyReadLine(short fp, unsigned char *theptr, short KillIt)
{
	ParamBlockRec	pb;
	short				err;
	
	pb.ioParam.ioCompletion = nil;
	pb.ioParam.ioPosMode = fsAtMark | 0x0D80;	/* newline mode */
	pb.ioParam.ioResult = 0;
	pb.ioParam.ioRefNum = fp;
	pb.ioParam.ioBuffer = (char *)theptr;
	pb.ioParam.ioReqCount = 256L;
	pb.ioParam.ioPosOffset = 0L;
	err = PBRead(&pb,FALSE);
	if(pb.ioParam.ioActCount > 0){
		if(KillIt)
			theptr += pb.ioParam.ioActCount - 1;	/* put a null where the cr was */
		else
			theptr += pb.ioParam.ioActCount;
		*theptr = 0;
	}
	return(pb.ioParam.ioActCount);
}
